



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Vimer的福音 新时代的Vim C++自动补全插件 clang_complete</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Vimer的福音 新时代的Vim C++自动补全插件 clang_complete</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 18:07:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><!--<br />
code, pre {<br />
    font-family: Monaco, Andale Mono, Courier New, monospace;<br />
}<br />
code {<br />
    background-color: #fee9cc;<br />
    color: rgba(0, 0, 0, 0.75);<br />
    padding: 1px 3px;<br />
    font-size: 12px;<br />
    -webkit-border-radius: 3px;<br />
    -moz-border-radius: 3px;<br />
    border-radius: 3px;<br />
}<br />
pre {<br />
    display: block;<br />
    padding: 14px;<br />
    margin: 0 0 18px;<br />
    line-height: 16px;<br />
    font-size: 11px;<br />
    border: 1px solid #d9d9d9;<br />
    white-space: pre-wrap;<br />
    word-wrap: break-word;<br />
}<br />
pre code {<br />
    background-color: #fff;<br />
    color:#737373;<br />
    font-size: 11px;<br />
    padding: 0;<br />
}<br />
--></p>
<p>使用vim的各位肯定尝试过各种各样的自动补全插件，比如说大名鼎鼎的 <a href="http://www.vim.org/scripts/script.php?script_id=1520" rel="external nofollow noreferrer">OmniCppComplete</a> 。这一类的插件都是对 <a href="http://ctags.sourceforge.net" rel="external nofollow noreferrer">Ctags</a> 生成的符号表进行字符串匹配来获得可能的补全项。他们在编写 C 代码的时候还是很好用的，但是到了 C++ 的环境情况就不同了，各种作用域的存在使得仅仅依靠符号表匹配的方式完全无法发挥作用。</p>
<p>比如我输入一个 SomeType 的对象 bar，然后我想得到成员变量 a 的提示，但是却没有任何事情发生：</p>
<pre class="prettyprint linenums"><code>struct SomeType { int a; };<br />
void foo()<br />
{<br />
    SomeType bar;<br />
    bar. // 咦。。。<br />
}<br />
</code></pre>
<p>有人会问：那像 Visual Studio 中的 <a href="http://msdn.microsoft.com/zh-cn/library/vstudio/hcw1s69b.aspx" rel="external nofollow noreferrer">IntelliSense</a> 怎么会有那么好的补全功能呢？</p>
<p>这是因为它利用了微软的 CL 编译器的功能对代码进行语法分析，这样一来补全工具就知道了各个符号所表示的到底是函数还是类型还是变量，同时也知道了一个作用域里都有那些符号，那么在补全的时候就的心应手了。</p>
<p>然后有人又要问了：如果我们的插件也利用上编译器的语法分析功能那就不行了吗？</p>
<p>为了解决这一问题，我们首先可以想到的是利用大家所熟知的 GCC 。但是 GCC 对第三方应用的支持很差，没有直接的编程接口，一般的应用只能自己解析 GCC 生成的中间文件来获得所需的信息，这样的方式既费时又容易出错。</p>
<p>那有什么其他的替代方式呢？</p>
<p>接下来，我要隆重地介绍新时代的编译器 <a href="http://clang.llvm.org/" rel="external nofollow noreferrer">Clang</a>，这个基于 <a href="http://www.llvm.org" rel="external nofollow noreferrer">LLVM</a> 的编译器有着比 GCC 更快的编译速度和更人性化的错误提示，并且支持 C, C++, Objective-C 和 Objective-C++。更重要的是 <a href="http://clang.llvm.org/" rel="external nofollow noreferrer">Clang</a> 提供了大量的 API 来供第三方应用调用，甚至直接就有获得自动补全提示的接口。</p>
<p>我们今天的主角 <a href="http://www.vim.org/scripts/script.php?script_id=3302" rel="external nofollow noreferrer">clang_complete</a> 就是一款基于 <a href="http://clang.llvm.org/" rel="external nofollow noreferrer">Clang</a> 的插件。</p>
<h3>安装方法</h3>
<ul><li><p><strong>安装前提</strong></p>
<p>Vim 7.3 或更高版本</p>
<p>Clang 3.0 或更高版本</p>
<p>没有安装 OmniCppComplete</p></li>
<li><p><strong>直接下载安装</strong></p>
<p><a href="http://www.vim.org/scripts/download_script.php?src_id=19588" rel="external nofollow noreferrer">下载点我</a></p>
<pre class="prettyprint linenums"><code>$ vim clang_complete.vmb -c 'so %' -c 'q'<br />
</code></pre></li>
<li><p><strong>从 Github 获得并生成 (需要python)</strong></p>
<pre class="prettyprint linenums"><code>$ git clone https://github.com/Rip-Rip/clang_complete.git<br />
$ make<br />
$ vim clang_complete.vmb -c 'so %' -c 'q'<br />
</code></pre></li></ul>
<h3>使用方法</h3>
<ul><li>输入类名或命名空间接 :: 之后就会有域成员的提示</li>
<li>输入对象名接 . 之后会有成员符号的提示</li>
<li>输入对象指针接 -&gt; 之后会有成员符号的提示</li>
<li>使用 Ctrl + N 强制打开补全列表</li>
<li>分别使用 Ctrl + N 和 Ctrl + P 来下翻和上翻</li></ul>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/416103/201309/08000329-5a3f02b750e148f7a5bfd1d1abf35176.jpg" /></p>
<p>好了话不多说，装上插件好好地享受 coding 吧！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1zlr29.html">Java程序设计求出岁数</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4zy539.html">lua获取时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq433o58.html">Think PHP项目在阿里云的虚拟主机上部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/39057rmq.html">Spring MVC和Struts2的比较的优点</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elkzjq.html">【转】AngularJS 取消对 HTML 片段的转义</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q75d7k9.html">hdu 1797 靠谱的算法应该是最大生成树，但是本人用最大流做的</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw2e0yq.html">Xcode 文档注释方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xrpye8.html">11&period;Java反射机制 哦对了&comma;前面的序号来自随笔关于编程之路的思索第一篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xp2ln9.html">python中有趣的函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15x1r9.html">FPGA笔记-读取&period;dat文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmp1209.html">Photoshop CS4 启动弹出许可协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwl5y9.html">WCF小实例以及三种宿主</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zxkrj9.html">CF618G（利用浮点数精度&plus;矩乘优化DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvdjdk8.html">java第11周</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyvn4mq.html">SQL FULL JOIN 关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r5z648.html">C&period; Painting the Fence</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m24nepq.html">工具链接redis</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvev3nx9.html">eclipse中可以导入其它工具编写的RobotFramework脚本吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/963m46j9.html">shell脚本技巧记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppyj279.html">（转）AssetBundle系列&mdash;&mdash;游戏资源打包（二）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq10yk58.html">关于UITextView &sol; String的尺寸</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oz3519.html">关于android使用ksoap2报Caused by&colon; java&period;lang&period;ClassCastException&colon; org&period;ksoap2&period;SoapFault cannot be cast to org&period;ksoap2&period;serialization&period;SoapObject</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2oyj39.html">Visual Studio 2015官方汇总包括下载和视频</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kyl1r9.html">Moqui之时间转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ozw5x9.html">linux php配置ftp扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/390zn1mq.html">java线程技术6&lowbar;线程的挂起和唤醒&lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jw6z08.html">使用Struts2和jQuery EasyUI实现简单CRUD系统（转载汇总）</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv6p0o8.html">G-nav-01</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ky6v69.html">视频播放实时记录日志并生成XML文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93e1prq.html">看css发现一个pointer-events&colon;none&semi;的东西</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
